#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <ctime>
#include <unistd.h>

#include "errors.h"
#include "utils.h"
#define MAX 100
#define VERSION 1.9
#define EPS 1.0e-14   // a bit larger than machine accuracy
#define GOP   1       // output flag for goplot
#define GNU   2       // output flag for gnuplot
#define GNUPS 3       // output flag for gnuplot postscript
#define FRACT .05     // amount by which x is extended for graph

typedef double dbl ;
typedef const char cchr ;

typedef struct {      // flag structure
    unsigned
    q,                // quiet screen output flag
    o,                // outfile option flag
    sflg ;            // sigma option flag
} flags;

typedef struct {      // data structure
    dbl *x, *y, *s;
    dbl xmin, xmax;   // limits of x[i]
    FILE *ifp;        // input file pointer
    int npts;
} data;

typedef struct {      // result structure
    dbl
    a,                // slope
    b,                // intercept
    siga,             // slope confidence interval
    sigb,             // intercept confidence interval
    chi2,             // chi-square
    corr;             // correlation coefficient
    FILE *ofp;        // output file pointer
    char nam[100];    // for output file name
} result;

void prn_info(void);
void prn_usage(void);
int get_npts(data*);
void get_data(char**, data*, flags*);
void get_opts(int, char**, flags* ) ;
void calculate(data*, result*, flags*);
dbl student(int, dbl);
dbl stud(dbl, int);
dbl norm(int);
void prn_results(data*, result*, flags*);
void mk_outfile(data*, result*, flags*);
