       /*********************************************
       *    returns incomplete gamma function       *
       *          Q(a,x) = 1 - P(a,x)               *
       * this is a modification of the code given   *
       * by press 2/e page 218, to make convergence *
       * better. converges for 0.0 < a <= 2624 now. *
       * written 5/18/97                            *
       *********************************************/

#include "util.h"

float gammq(float a, float x)
{
    float gamser,  /* for the series rep */
          gamcf,   /* for the continued fraction rep */
          lng ;    /* log of gamma(a) */

    if ( x < 0.0 || a <= 0.0 )
        errss( "invalid arguments in %s", "gammq" ) ;
    if ( x > 3.0 ) {
        if ( x <= a - 1.0 ) {
            gser( &gamser, a, x, &lng ) ;
            return 1.0 - gamser ;
        }
        else {     /* x == a - 1.0 not allowed in gcf */
            gcf( &gamcf, a, x, &lng ) ;
            return gamcf ;
        }
    }
    else {  /* 0.0 <= x <= 3.0 */
        if ( x < a + 1.0 ) {
            gser( &gamser, a, x, &lng ) ;
            return 1.0 - gamser ;
        }
        else {
            gcf( &gamcf, a, x, &lng ) ;
            return gamcf ;
        }
    }
}

