#include "fitline.h"

void get_data(char** argv, data* dp, flags* fp)
{
	extern int optind;
    int i, j, m, first_line = true, msave = 0;
    char tmp[MAX];
    dbl dummy;
    dp->npts = 0;

    for (i = 0 ; fgets(tmp, MAX, dp->ifp) != 0 ; ++i) {
        if (strstr( tmp, "#")) continue;    // ignore comment lines
        j = dp->npts ;
        m = sscanf( tmp, "%lg%lg%lg%lg",
               &dp->x[j], &dp->y[j], &dp->s[j], &dummy ) ;
        if ( first_line ) {
            msave = m;                      // for checking consistency
            dp->xmin = dp->xmax = dp->x[j]; // initialize xmin, xmax
            first_line = false;
        }
        if (m > 3) {
            err("found more than three columns in \"",
					argv[optind],
                   "\" at line ", i+1);
        }
        if (m < 2) {
            err("found a blank or inappropriate line in \"",
					argv[optind],
					"\" at line ", i+1);
        }
        if (m == 2) {
            if ( fp->sflg ) {
                err("did not find an s[i] in \"",
						argv[optind],
						"\" at line ", i+1);
            }
            else {
                dp->s[j] = 1.0;             // provide equal weights
            }
        }
        if ( m != msave ) {
            err("format not consistent in \"",
					argv[optind],
                   "\" at line ", i+1);
        }
        dp->xmin = dp->xmin > dp->x[j] ? dp->x[j] : dp->xmin;
        dp->xmax = dp->xmax < dp->x[j] ? dp->x[j] : dp->xmax;
        dp->npts++;
    }
}
