////////////////////////////////////////
// gets the options from the command  //
// line, and sets various flags.      //
////////////////////////////////////////

#include "fitline.h"

void get_opts( int argc, char **argv, flags* fp ) {

    extern int opterr;
    extern char *optarg;
    int i ;

    opterr = true;

    while (( i = getopt( argc, argv, "hg:s:v" )) != -1 ) {
        switch (i) {
            case 'h':      // display help file
                prn_info() ;
                exit( 0 ) ;
                break ;
            case 'g':      // make output file for plotting
                if ( !strcmp( optarg, "oplot" )) {
                    fp->o = GOP ;
                }
                else if ( !strcmp( optarg, "nuplot" )) {
                    fp->o = GNU ;
                }
                else if ( !strcmp( optarg, "nups" )) {
                    fp->o = GNUPS ;
                }
                else {
                    prn_usage() ;
                       exit( 1 ) ;
                }
                break ;
            case 's':      // if "absolute" sigmas supplied
                if ( strcmp( optarg, "igma" )) {
                    prn_usage() ;
                    exit( 1 ) ;
                }
                else {
                    fp->sflg = true;
                }
                break ;
            case 'v':      // print version number
                fprintf( stderr, "%s version %3.1f\n", argv[0], VERSION ) ;
                exit( 0 ) ;
                break ;
            case '?':      // for unrecognized option
                prn_usage() ;
                exit( 1 ) ;
        }
    }
}
