//
// main program for fitline
//

#include "fitline.h"

int main(int argc, char** argv)
{
    extern int optind ;
    flags f = {false},                   // structure for option flags
        *fp = &f;
    data d,                              // structure for data
        *dp = &d;
    result r = {0.0},                    // structure for results
        *rp = &r;

    if (argc < 2) {
        prn_usage();
        exit(1);
    }
    get_opts(argc, argv, fp);            // get options
    if (argc == optind + 1) {            // open datafile
        d.ifp = gfopen(argv[optind], "r");
    }
    d.npts = get_npts( dp ) ;            // count data points
    d.x = dvector( d.npts ) ;            // allocate memory
    d.y = dvector( d.npts ) ;
    d.s = dvector( d.npts ) ;
    get_data(argv, dp, fp ) ;                 // get data and xmin, xmax
    gfclose( dp->ifp ) ;                 // close datafile
    calculate( dp, rp, fp ) ;            // do the calculations
    if ( f.o == GOP ) {                  // goplot option
        strcpy( r.nam, argv[optind] ) ;
        strcat( r.nam, ".go" ) ;         // outfile is "datafile.go"
        r.ofp = gfopen( r.nam, "w" ) ;   // open outfile
        mk_outfile( dp, rp, fp ) ;       // create outfile
    }
    if ( f.o == GNU ) {                  // gnuplot option
        strcpy( r.nam, argv[optind] ) ;
        strcat( r.nam, ".gnu" ) ;        // outfile is "datafile.gnu"
        r.ofp = gfopen( r.nam, "w" ) ;   // open outfile
        mk_outfile( dp, rp, fp ) ;       // create outfile
    }
	if ( f.o == GNUPS ) {
		strcpy( r.nam, argv[optind] ) ;
		strcat( r.nam, ".gnups" ) ;
		r.ofp = gfopen( r.nam, "w" ) ;
		mk_outfile( dp, rp, fp ) ;
	}
    prn_results( dp, rp, fp ) ;          // print results on the screen
    free( d.x ) ;
    free( d.y ) ;
    free( d.s ) ;
}
