//////////////////////////////////////////////////////////
// prints results on the terminal screen.  this         //
// output may also be redirected to a file if desired.  //
//////////////////////////////////////////////////////////

#include "fitline.h"

void prn_results(data* dp, result* rp, flags* fp)
{
    char date[100];
    time_t now = time( NULL );
    dbl alpha ;

    strftime( date, 100, "at %l:%M %p on %b %d, %Y", localtime( &now) ) ;
    printf( "\n%s...\n", date ) ;
    printf( "number of data points = %d\n", dp->npts ) ;
    printf( "slope      = %#8.6g +/- %#7.5g\n", rp->a, rp->siga ) ;
    printf( "intercept  = %#8.6g +/- %#7.5g\n", rp->b, rp->sigb ) ;
    if ( fp->sflg ) {
        alpha = gammq( 0.5*(dp->npts - 2), 0.5*(rp->chi2)) ;
        printf( "chi-square = %#8.2f\n", rp->chi2 ) ;
    printf("%s%4.2f\n",
      "  The value of alpha--the probability that a larger\n"
      "  value of chi-square would be obtained for an\n"
      "  equivalent data set, assuming the straight-line\n"
      "  model to be a good one, is equal to ", alpha ) ;
    }
    else {
           printf("%s\n",
              "  (chi-square is not available-- \n"
              "  a straight-line fit is ASSUMED.)");
    }
    printf( "correlation coefficient = %#.3f\n", rp->corr ) ;
    if ( fp->o == GOP ) {
        printf( "%s%s%s%s\".",
		  "\nok, now producing the file \"",
		  rp->nam,
		  "\" ...\n"
		  "To see a graph, try \"goplot ",
		  rp->nam ) ;
    }
    if ( fp->o == GNU ) {
        printf( "%s%s%s%s\".",
		  "\nok, now producing the file \"",
		  rp->nam,
		  "\" ...\n"
		  "To see a graph, try \"gnuplot ",
		  rp->nam ) ;
    }
    if ( fp->o == GNUPS ) {
        printf( "%s%s%s%s\".",
		  "\nok, now producing the file \"",
		  rp->nam,
		  "\" ...\n"
		  "To get a printed graph, try \"gnuplot ",
		  rp->nam ) ;
    }
    printf( "\n" ) ;
}
